Subject: Re: bug#50784: coreutils 9.0 sometimes gets spurious failures in chmod -R

From: Pádraig Brady <[email-masked]>
Date: Fri, 24 Sep 2021 20:29:03 +0100

On 24/09/2021 19:21, Daniel Schepler wrote:
> After I upgraded my system (locally built) to coreutils 9.0, I noticed
> that my lightly modified sbuild started getting build failures when it
> tries to run "chmod -R g+w /<<BUILDDIR>>" (as root) in the chroot.
> I'm not sure exactly what combination of files triggers the error, but
> I'm able to reproduce it roughly as follows:
> 
> cd /tmp
> tar -x -f .../coreutils-9.0.tar.xz
> cd coreutils-9.0
> mkdir obj-x86_64-linux-gnu
> cd obj-x86_64-linux-gnu
> ../configure --prefix=/usr
> make -j8
> chmod -R u+w /tmp/coreutils-9.0/obj-x86_64-linux-gnu
> echo $?
> 
> In the last chmod command, there are no failures reported; and even if
> I run it under strace, I see no hints of any failed system calls other
> than one in access("/etc/ld.so.preload", R_OK) at startup -- and
> certainly no failures in the fchmodat() system calls.  Yet the exit
> code from the process is 1.
> 
> I wasn't seeing any such errors under sbuild using coreutils 8.32.

Drats. I think it's determining ignoring symlinks as an error.
Could you try with the following untested diff:

diff --git a/src/chmod.c b/src/chmod.c
index 37b04f500..9ab60898d 100644
--- a/src/chmod.c
+++ b/src/chmod.c
@@ -322,6 +322,9 @@ process_file (FTS *fts, FTSENT *ent)
    if ( ! recurse)
      fts_set (fts, ent, FTS_SKIP);

+  if (ch.status == CH_NOT_APPLIED)  /* For symlinks.  */
+    ch.status = CH_NO_CHANGE_REQUESTED;
+
    return CH_NO_CHANGE_REQUESTED <= ch.status;
  }